com.amazonaws.services.simpleworkflow.model

## Class Decision

- java.lang.Object
- - com.amazonaws.services.simpleworkflow.model.Decision

All Implemented Interfaces:
  Serializable, Cloneable

    public class Decision
    extends Object
    implements Serializable, Cloneable

Specifies a decision made by the decider. A decision can be one of these types:

- CancelTimer: cancels a previously started timer and records a `TimerCanceled` event in the history.
- CancelWorkflowExecution: closes the workflow execution and records a `WorkflowExecutionCanceled` event in the history.
- CompleteWorkflowExecution: closes the workflow execution and records a `WorkflowExecutionCompleted` event in the history .
- ContinueAsNewWorkflowExecution: closes the workflow execution and starts a new workflow execution of the same type using the same workflow ID and a unique run ID. A `WorkflowExecutionContinuedAsNew` event is recorded in the history.
- FailWorkflowExecution: closes the workflow execution and records a `WorkflowExecutionFailed` event in the history.
- RecordMarker: records a `MarkerRecorded` event in the history. Markers can be used for adding custom information in the history for instance to let deciders know that they do not need to look at the history beyond the marker event.
- RequestCancelActivityTask: attempts to cancel a previously scheduled activity task. If the activity task was scheduled but has not been assigned to a worker, then it will be canceled. If the activity task was already assigned to a worker, then the worker will be informed that cancellation has been requested in the response to RecordActivityTaskHeartbeat.
- RequestCancelExternalWorkflowExecution: requests that a request be made to cancel the specified external workflow execution and records a `RequestCancelExternalWorkflowExecutionInitiated` event in the history.
- ScheduleActivityTask: schedules an activity task.
- ScheduleLambdaFunction: schedules a AWS Lambda function.
- SignalExternalWorkflowExecution: requests a signal to be delivered to the specified external workflow execution and records a `SignalExternalWorkflowExecutionInitiated` event in the history.
- StartChildWorkflowExecution: requests that a child workflow execution be started and records a `StartChildWorkflowExecutionInitiated` event in the history. The child workflow execution is a separate workflow execution with its own history.
- StartTimer: starts a timer for this workflow execution and records a `TimerStarted` event in the history. This timer will fire after the specified delay and record a `TimerFired` event.

Access Control

If you grant permission to use `RespondDecisionTaskCompleted`, you can use IAM policies to express permissions for the list of decisions returned by this action as if they were members of the API. Treating decisions as a pseudo API maintains a uniform conceptual model and helps keep policies readable. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

Decision Failure

Decisions can fail for several reasons

- The ordering of decisions should follow a logical flow. Some decisions might not make sense in the current context of the workflow execution and will therefore fail.
- A limit on your account was reached.
- The decision lacks sufficient permissions.

One of the following events might be added to the history to indicate an error. The event attribute's cause parameter indicates the cause. If cause is set to OPERATION_NOT_PERMITTED, the decision failed because it lacked sufficient permissions. For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows.

- ScheduleActivityTaskFailed: a ScheduleActivityTask decision failed. This could happen if the activity type specified in the decision is not registered, is in a deprecated state, or the decision is not properly configured.
- ScheduleLambdaFunctionFailed: a ScheduleLambdaFunctionFailed decision failed. This could happen if the AWS Lambda function specified in the decision does not exist, or the AWS Lambda service's limits are exceeded.
- RequestCancelActivityTaskFailed: a RequestCancelActivityTask decision failed. This could happen if there is no open activity task with the specified activityId.
- StartTimerFailed: a StartTimer decision failed. This could happen if there is another open timer with the same timerId.
- CancelTimerFailed: a CancelTimer decision failed. This could happen if there is no open timer with the specified timerId.
- StartChildWorkflowExecutionFailed: a StartChildWorkflowExecution decision failed. This could happen if the workflow type specified is not registered, is deprecated, or the decision is not properly configured.
- SignalExternalWorkflowExecutionFailed: a SignalExternalWorkflowExecution decision failed. This could happen if the `workflowID` specified in the decision was incorrect.
- RequestCancelExternalWorkflowExecutionFailed: a RequestCancelExternalWorkflowExecution decision failed. This could happen if the `workflowID` specified in the decision was incorrect.
- CancelWorkflowExecutionFailed: a CancelWorkflowExecution decision failed. This could happen if there is an unhandled decision task pending in the workflow execution.
- CompleteWorkflowExecutionFailed: a CompleteWorkflowExecution decision failed. This could happen if there is an unhandled decision task pending in the workflow execution.
- ContinueAsNewWorkflowExecutionFailed: a ContinueAsNewWorkflowExecution decision failed. This could happen if there is an unhandled decision task pending in the workflow execution or the ContinueAsNewWorkflowExecution decision was not configured correctly.
- FailWorkflowExecutionFailed: a FailWorkflowExecution decision failed. This could happen if there is an unhandled decision task pending in the workflow execution.

The preceding error events might occur due to an error in the decider logic, which might put the workflow execution in an unstable state The cause field in the event structure for the error event indicates the cause of the error.

<note>A workflow execution may be closed by the decider by returning one of the following decisions when completing a decision task: `CompleteWorkflowExecution`, `FailWorkflowExecution`, `CancelWorkflowExecution` and `ContinueAsNewWorkflowExecution`. An UnhandledDecision fault will be returned if a workflow closing decision is specified and a signal or activity event had been added to the history while the decision task was being performed by the decider. Unlike the above situations which are logic issues, this fault is always possible because of race conditions in a distributed system. The right action here is to call RespondDecisionTaskCompleted without any decisions. This would result in another decision task with these new events included in the history. The decider should handle the new events and may decide to close the workflow execution.</note>

How to code a decision

You code a decision by first setting the decision type field to one of the above decision values, and then set the corresponding attributes field shown below:

- ScheduleActivityTaskDecisionAttributes
- ScheduleLambdaFunctionDecisionAttributes
- RequestCancelActivityTaskDecisionAttributes
- CompleteWorkflowExecutionDecisionAttributes
- FailWorkflowExecutionDecisionAttributes
- CancelWorkflowExecutionDecisionAttributes
- ContinueAsNewWorkflowExecutionDecisionAttributes
- RecordMarkerDecisionAttributes
- StartTimerDecisionAttributes
- CancelTimerDecisionAttributes
- SignalExternalWorkflowExecutionDecisionAttributes
- RequestCancelExternalWorkflowExecutionDecisionAttributes
- StartChildWorkflowExecutionDecisionAttributes

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`Decision()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Decision` `clone()`
`boolean` `equals(Object obj)`
`CancelTimerDecisionAttributes` `getCancelTimerDecisionAttributes()` Provides details of the `CancelTimer` decision.
`CancelWorkflowExecutionDecisionAttributes` `getCancelWorkflowExecutionDecisionAttributes()` Provides details of the `CancelWorkflowExecution` decision.
`CompleteWorkflowExecutionDecisionAttributes` `getCompleteWorkflowExecutionDecisionAttributes()` Provides details of the `CompleteWorkflowExecution` decision.
`ContinueAsNewWorkflowExecutionDecisionAttributes` `getContinueAsNewWorkflowExecutionDecisionAttributes()` Provides details of the `ContinueAsNewWorkflowExecution` decision.
`String` `getDecisionType()` Specifies the type of the decision.
`FailWorkflowExecutionDecisionAttributes` `getFailWorkflowExecutionDecisionAttributes()` Provides details of the `FailWorkflowExecution` decision.
`RecordMarkerDecisionAttributes` `getRecordMarkerDecisionAttributes()` Provides details of the `RecordMarker` decision.
`RequestCancelActivityTaskDecisionAttributes` `getRequestCancelActivityTaskDecisionAttributes()` Provides details of the `RequestCancelActivityTask` decision.
`RequestCancelExternalWorkflowExecutionDecisionAttributes` `getRequestCancelExternalWorkflowExecutionDecisionAttributes()` Provides details of the `RequestCancelExternalWorkflowExecution` decision.
`ScheduleActivityTaskDecisionAttributes` `getScheduleActivityTaskDecisionAttributes()` Provides details of the `ScheduleActivityTask` decision.
`ScheduleLambdaFunctionDecisionAttributes` `getScheduleLambdaFunctionDecisionAttributes()`
`SignalExternalWorkflowExecutionDecisionAttributes` `getSignalExternalWorkflowExecutionDecisionAttributes()` Provides details of the `SignalExternalWorkflowExecution` decision.
`StartChildWorkflowExecutionDecisionAttributes` `getStartChildWorkflowExecutionDecisionAttributes()` Provides details of the `StartChildWorkflowExecution` decision.
`StartTimerDecisionAttributes` `getStartTimerDecisionAttributes()` Provides details of the `StartTimer` decision.
`int` `hashCode()`
`void` `setCancelTimerDecisionAttributes(CancelTimerDecisionAttributes cancelTimerDecisionAttributes)` Provides details of the `CancelTimer` decision.
`void` `setCancelWorkflowExecutionDecisionAttributes(CancelWorkflowExecutionDecisionAttributes cancelWorkflowExecutionDecisionAttributes)` Provides details of the `CancelWorkflowExecution` decision.
`void` `setCompleteWorkflowExecutionDecisionAttributes(CompleteWorkflowExecutionDecisionAttributes completeWorkflowExecutionDecisionAttributes)` Provides details of the `CompleteWorkflowExecution` decision.
`void` `setContinueAsNewWorkflowExecutionDecisionAttributes(ContinueAsNewWorkflowExecutionDecisionAttributes continueAsNewWorkflowExecutionDecisionAttributes)` Provides details of the `ContinueAsNewWorkflowExecution` decision.
`void` `setDecisionType(DecisionType decisionType)` Specifies the type of the decision.
`void` `setDecisionType(String decisionType)` Specifies the type of the decision.
`void` `setFailWorkflowExecutionDecisionAttributes(FailWorkflowExecutionDecisionAttributes failWorkflowExecutionDecisionAttributes)` Provides details of the `FailWorkflowExecution` decision.
`void` `setRecordMarkerDecisionAttributes(RecordMarkerDecisionAttributes recordMarkerDecisionAttributes)` Provides details of the `RecordMarker` decision.
`void` `setRequestCancelActivityTaskDecisionAttributes(RequestCancelActivityTaskDecisionAttributes requestCancelActivityTaskDecisionAttributes)` Provides details of the `RequestCancelActivityTask` decision.
`void` `setRequestCancelExternalWorkflowExecutionDecisionAttributes(RequestCancelExternalWorkflowExecutionDecisionAttributes requestCancelExternalWorkflowExecutionDecisionAttributes)` Provides details of the `RequestCancelExternalWorkflowExecution` decision.
`void` `setScheduleActivityTaskDecisionAttributes(ScheduleActivityTaskDecisionAttributes scheduleActivityTaskDecisionAttributes)` Provides details of the `ScheduleActivityTask` decision.
`void` `setScheduleLambdaFunctionDecisionAttributes(ScheduleLambdaFunctionDecisionAttributes scheduleLambdaFunctionDecisionAttributes)`
`void` `setSignalExternalWorkflowExecutionDecisionAttributes(SignalExternalWorkflowExecutionDecisionAttributes signalExternalWorkflowExecutionDecisionAttributes)` Provides details of the `SignalExternalWorkflowExecution` decision.
`void` `setStartChildWorkflowExecutionDecisionAttributes(StartChildWorkflowExecutionDecisionAttributes startChildWorkflowExecutionDecisionAttributes)` Provides details of the `StartChildWorkflowExecution` decision.
`void` `setStartTimerDecisionAttributes(StartTimerDecisionAttributes startTimerDecisionAttributes)` Provides details of the `StartTimer` decision.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`Decision` `withCancelTimerDecisionAttributes(CancelTimerDecisionAttributes cancelTimerDecisionAttributes)` Provides details of the `CancelTimer` decision.
`Decision` `withCancelWorkflowExecutionDecisionAttributes(CancelWorkflowExecutionDecisionAttributes cancelWorkflowExecutionDecisionAttributes)` Provides details of the `CancelWorkflowExecution` decision.
`Decision` `withCompleteWorkflowExecutionDecisionAttributes(CompleteWorkflowExecutionDecisionAttributes completeWorkflowExecutionDecisionAttributes)` Provides details of the `CompleteWorkflowExecution` decision.
`Decision` `withContinueAsNewWorkflowExecutionDecisionAttributes(ContinueAsNewWorkflowExecutionDecisionAttributes continueAsNewWorkflowExecutionDecisionAttributes)` Provides details of the `ContinueAsNewWorkflowExecution` decision.
`Decision` `withDecisionType(DecisionType decisionType)` Specifies the type of the decision.
`Decision` `withDecisionType(String decisionType)` Specifies the type of the decision.
`Decision` `withFailWorkflowExecutionDecisionAttributes(FailWorkflowExecutionDecisionAttributes failWorkflowExecutionDecisionAttributes)` Provides details of the `FailWorkflowExecution` decision.
`Decision` `withRecordMarkerDecisionAttributes(RecordMarkerDecisionAttributes recordMarkerDecisionAttributes)` Provides details of the `RecordMarker` decision.
`Decision` `withRequestCancelActivityTaskDecisionAttributes(RequestCancelActivityTaskDecisionAttributes requestCancelActivityTaskDecisionAttributes)` Provides details of the `RequestCancelActivityTask` decision.
`Decision` `withRequestCancelExternalWorkflowExecutionDecisionAttributes(RequestCancelExternalWorkflowExecutionDecisionAttributes requestCancelExternalWorkflowExecutionDecisionAttributes)` Provides details of the `RequestCancelExternalWorkflowExecution` decision.
`Decision` `withScheduleActivityTaskDecisionAttributes(ScheduleActivityTaskDecisionAttributes scheduleActivityTaskDecisionAttributes)` Provides details of the `ScheduleActivityTask` decision.
`Decision` `withScheduleLambdaFunctionDecisionAttributes(ScheduleLambdaFunctionDecisionAttributes scheduleLambdaFunctionDecisionAttributes)`
`Decision` `withSignalExternalWorkflowExecutionDecisionAttributes(SignalExternalWorkflowExecutionDecisionAttributes signalExternalWorkflowExecutionDecisionAttributes)` Provides details of the `SignalExternalWorkflowExecution` decision.
`Decision` `withStartChildWorkflowExecutionDecisionAttributes(StartChildWorkflowExecutionDecisionAttributes startChildWorkflowExecutionDecisionAttributes)` Provides details of the `StartChildWorkflowExecution` decision.
`Decision` `withStartTimerDecisionAttributes(StartTimerDecisionAttributes startTimerDecisionAttributes)` Provides details of the `StartTimer` decision.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Decision

    public Decision()

### Method Detail

#### setDecisionType

    public void setDecisionType(String decisionType)

Specifies the type of the decision.

Parameters:
  `decisionType` - Specifies the type of the decision.
See Also:
  `DecisionType`

#### getDecisionType

    public String getDecisionType()

Specifies the type of the decision.

Returns:
  Specifies the type of the decision.
See Also:
  `DecisionType`

#### withDecisionType

    public Decision withDecisionType(String decisionType)

Specifies the type of the decision.

Parameters:
  `decisionType` - Specifies the type of the decision.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `DecisionType`

#### setDecisionType

    public void setDecisionType(DecisionType decisionType)

Specifies the type of the decision.

Parameters:
  `decisionType` - Specifies the type of the decision.
See Also:
  `DecisionType`

#### withDecisionType

    public Decision withDecisionType(DecisionType decisionType)

Specifies the type of the decision.

Parameters:
  `decisionType` - Specifies the type of the decision.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `DecisionType`

#### setScheduleActivityTaskDecisionAttributes

    public void setScheduleActivityTaskDecisionAttributes(ScheduleActivityTaskDecisionAttributes scheduleActivityTaskDecisionAttributes)

Provides details of the `ScheduleActivityTask` decision. It is not set for other decision types.

Parameters:
  `scheduleActivityTaskDecisionAttributes` - Provides details of the `ScheduleActivityTask` decision. It is not set for other decision types.

#### getScheduleActivityTaskDecisionAttributes

    public ScheduleActivityTaskDecisionAttributes getScheduleActivityTaskDecisionAttributes()

Provides details of the `ScheduleActivityTask` decision. It is not set for other decision types.

Returns:
  Provides details of the `ScheduleActivityTask` decision. It is not set for other decision types.

#### withScheduleActivityTaskDecisionAttributes

    public Decision withScheduleActivityTaskDecisionAttributes(ScheduleActivityTaskDecisionAttributes scheduleActivityTaskDecisionAttributes)

Provides details of the `ScheduleActivityTask` decision. It is not set for other decision types.

Parameters:
  `scheduleActivityTaskDecisionAttributes` - Provides details of the `ScheduleActivityTask` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setRequestCancelActivityTaskDecisionAttributes

    public void setRequestCancelActivityTaskDecisionAttributes(RequestCancelActivityTaskDecisionAttributes requestCancelActivityTaskDecisionAttributes)

Provides details of the `RequestCancelActivityTask` decision. It is not set for other decision types.

Parameters:
  `requestCancelActivityTaskDecisionAttributes` - Provides details of the `RequestCancelActivityTask` decision. It is not set for other decision types.

#### getRequestCancelActivityTaskDecisionAttributes

    public RequestCancelActivityTaskDecisionAttributes getRequestCancelActivityTaskDecisionAttributes()

Provides details of the `RequestCancelActivityTask` decision. It is not set for other decision types.

Returns:
  Provides details of the `RequestCancelActivityTask` decision. It is not set for other decision types.

#### withRequestCancelActivityTaskDecisionAttributes

    public Decision withRequestCancelActivityTaskDecisionAttributes(RequestCancelActivityTaskDecisionAttributes requestCancelActivityTaskDecisionAttributes)

Provides details of the `RequestCancelActivityTask` decision. It is not set for other decision types.

Parameters:
  `requestCancelActivityTaskDecisionAttributes` - Provides details of the `RequestCancelActivityTask` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setCompleteWorkflowExecutionDecisionAttributes

    public void setCompleteWorkflowExecutionDecisionAttributes(CompleteWorkflowExecutionDecisionAttributes completeWorkflowExecutionDecisionAttributes)

Provides details of the `CompleteWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `completeWorkflowExecutionDecisionAttributes` - Provides details of the `CompleteWorkflowExecution` decision. It is not set for other decision types.

#### getCompleteWorkflowExecutionDecisionAttributes

    public CompleteWorkflowExecutionDecisionAttributes getCompleteWorkflowExecutionDecisionAttributes()

Provides details of the `CompleteWorkflowExecution` decision. It is not set for other decision types.

Returns:
  Provides details of the `CompleteWorkflowExecution` decision. It is not set for other decision types.

#### withCompleteWorkflowExecutionDecisionAttributes

    public Decision withCompleteWorkflowExecutionDecisionAttributes(CompleteWorkflowExecutionDecisionAttributes completeWorkflowExecutionDecisionAttributes)

Provides details of the `CompleteWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `completeWorkflowExecutionDecisionAttributes` - Provides details of the `CompleteWorkflowExecution` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setFailWorkflowExecutionDecisionAttributes

    public void setFailWorkflowExecutionDecisionAttributes(FailWorkflowExecutionDecisionAttributes failWorkflowExecutionDecisionAttributes)

Provides details of the `FailWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `failWorkflowExecutionDecisionAttributes` - Provides details of the `FailWorkflowExecution` decision. It is not set for other decision types.

#### getFailWorkflowExecutionDecisionAttributes

    public FailWorkflowExecutionDecisionAttributes getFailWorkflowExecutionDecisionAttributes()

Provides details of the `FailWorkflowExecution` decision. It is not set for other decision types.

Returns:
  Provides details of the `FailWorkflowExecution` decision. It is not set for other decision types.

#### withFailWorkflowExecutionDecisionAttributes

    public Decision withFailWorkflowExecutionDecisionAttributes(FailWorkflowExecutionDecisionAttributes failWorkflowExecutionDecisionAttributes)

Provides details of the `FailWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `failWorkflowExecutionDecisionAttributes` - Provides details of the `FailWorkflowExecution` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setCancelWorkflowExecutionDecisionAttributes

    public void setCancelWorkflowExecutionDecisionAttributes(CancelWorkflowExecutionDecisionAttributes cancelWorkflowExecutionDecisionAttributes)

Provides details of the `CancelWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `cancelWorkflowExecutionDecisionAttributes` - Provides details of the `CancelWorkflowExecution` decision. It is not set for other decision types.

#### getCancelWorkflowExecutionDecisionAttributes

    public CancelWorkflowExecutionDecisionAttributes getCancelWorkflowExecutionDecisionAttributes()

Provides details of the `CancelWorkflowExecution` decision. It is not set for other decision types.

Returns:
  Provides details of the `CancelWorkflowExecution` decision. It is not set for other decision types.

#### withCancelWorkflowExecutionDecisionAttributes

    public Decision withCancelWorkflowExecutionDecisionAttributes(CancelWorkflowExecutionDecisionAttributes cancelWorkflowExecutionDecisionAttributes)

Provides details of the `CancelWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `cancelWorkflowExecutionDecisionAttributes` - Provides details of the `CancelWorkflowExecution` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setContinueAsNewWorkflowExecutionDecisionAttributes

    public void setContinueAsNewWorkflowExecutionDecisionAttributes(ContinueAsNewWorkflowExecutionDecisionAttributes continueAsNewWorkflowExecutionDecisionAttributes)

Provides details of the `ContinueAsNewWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `continueAsNewWorkflowExecutionDecisionAttributes` - Provides details of the `ContinueAsNewWorkflowExecution` decision. It is not set for other decision types.

#### getContinueAsNewWorkflowExecutionDecisionAttributes

    public ContinueAsNewWorkflowExecutionDecisionAttributes getContinueAsNewWorkflowExecutionDecisionAttributes()

Provides details of the `ContinueAsNewWorkflowExecution` decision. It is not set for other decision types.

Returns:
  Provides details of the `ContinueAsNewWorkflowExecution` decision. It is not set for other decision types.

#### withContinueAsNewWorkflowExecutionDecisionAttributes

    public Decision withContinueAsNewWorkflowExecutionDecisionAttributes(ContinueAsNewWorkflowExecutionDecisionAttributes continueAsNewWorkflowExecutionDecisionAttributes)

Provides details of the `ContinueAsNewWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `continueAsNewWorkflowExecutionDecisionAttributes` - Provides details of the `ContinueAsNewWorkflowExecution` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setRecordMarkerDecisionAttributes

    public void setRecordMarkerDecisionAttributes(RecordMarkerDecisionAttributes recordMarkerDecisionAttributes)

Provides details of the `RecordMarker` decision. It is not set for other decision types.

Parameters:
  `recordMarkerDecisionAttributes` - Provides details of the `RecordMarker` decision. It is not set for other decision types.

#### getRecordMarkerDecisionAttributes

    public RecordMarkerDecisionAttributes getRecordMarkerDecisionAttributes()

Provides details of the `RecordMarker` decision. It is not set for other decision types.

Returns:
  Provides details of the `RecordMarker` decision. It is not set for other decision types.

#### withRecordMarkerDecisionAttributes

    public Decision withRecordMarkerDecisionAttributes(RecordMarkerDecisionAttributes recordMarkerDecisionAttributes)

Provides details of the `RecordMarker` decision. It is not set for other decision types.

Parameters:
  `recordMarkerDecisionAttributes` - Provides details of the `RecordMarker` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setStartTimerDecisionAttributes

    public void setStartTimerDecisionAttributes(StartTimerDecisionAttributes startTimerDecisionAttributes)

Provides details of the `StartTimer` decision. It is not set for other decision types.

Parameters:
  `startTimerDecisionAttributes` - Provides details of the `StartTimer` decision. It is not set for other decision types.

#### getStartTimerDecisionAttributes

    public StartTimerDecisionAttributes getStartTimerDecisionAttributes()

Provides details of the `StartTimer` decision. It is not set for other decision types.

Returns:
  Provides details of the `StartTimer` decision. It is not set for other decision types.

#### withStartTimerDecisionAttributes

    public Decision withStartTimerDecisionAttributes(StartTimerDecisionAttributes startTimerDecisionAttributes)

Provides details of the `StartTimer` decision. It is not set for other decision types.

Parameters:
  `startTimerDecisionAttributes` - Provides details of the `StartTimer` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setCancelTimerDecisionAttributes

    public void setCancelTimerDecisionAttributes(CancelTimerDecisionAttributes cancelTimerDecisionAttributes)

Provides details of the `CancelTimer` decision. It is not set for other decision types.

Parameters:
  `cancelTimerDecisionAttributes` - Provides details of the `CancelTimer` decision. It is not set for other decision types.

#### getCancelTimerDecisionAttributes

    public CancelTimerDecisionAttributes getCancelTimerDecisionAttributes()

Provides details of the `CancelTimer` decision. It is not set for other decision types.

Returns:
  Provides details of the `CancelTimer` decision. It is not set for other decision types.

#### withCancelTimerDecisionAttributes

    public Decision withCancelTimerDecisionAttributes(CancelTimerDecisionAttributes cancelTimerDecisionAttributes)

Provides details of the `CancelTimer` decision. It is not set for other decision types.

Parameters:
  `cancelTimerDecisionAttributes` - Provides details of the `CancelTimer` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setSignalExternalWorkflowExecutionDecisionAttributes

    public void setSignalExternalWorkflowExecutionDecisionAttributes(SignalExternalWorkflowExecutionDecisionAttributes signalExternalWorkflowExecutionDecisionAttributes)

Provides details of the `SignalExternalWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `signalExternalWorkflowExecutionDecisionAttributes` - Provides details of the `SignalExternalWorkflowExecution` decision. It is not set for other decision types.

#### getSignalExternalWorkflowExecutionDecisionAttributes

    public SignalExternalWorkflowExecutionDecisionAttributes getSignalExternalWorkflowExecutionDecisionAttributes()

Provides details of the `SignalExternalWorkflowExecution` decision. It is not set for other decision types.

Returns:
  Provides details of the `SignalExternalWorkflowExecution` decision. It is not set for other decision types.

#### withSignalExternalWorkflowExecutionDecisionAttributes

    public Decision withSignalExternalWorkflowExecutionDecisionAttributes(SignalExternalWorkflowExecutionDecisionAttributes signalExternalWorkflowExecutionDecisionAttributes)

Provides details of the `SignalExternalWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `signalExternalWorkflowExecutionDecisionAttributes` - Provides details of the `SignalExternalWorkflowExecution` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setRequestCancelExternalWorkflowExecutionDecisionAttributes

    public void setRequestCancelExternalWorkflowExecutionDecisionAttributes(RequestCancelExternalWorkflowExecutionDecisionAttributes requestCancelExternalWorkflowExecutionDecisionAttributes)

Provides details of the `RequestCancelExternalWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `requestCancelExternalWorkflowExecutionDecisionAttributes` - Provides details of the `RequestCancelExternalWorkflowExecution` decision. It is not set for other decision types.

#### getRequestCancelExternalWorkflowExecutionDecisionAttributes

    public RequestCancelExternalWorkflowExecutionDecisionAttributes getRequestCancelExternalWorkflowExecutionDecisionAttributes()

Provides details of the `RequestCancelExternalWorkflowExecution` decision. It is not set for other decision types.

Returns:
  Provides details of the `RequestCancelExternalWorkflowExecution` decision. It is not set for other decision types.

#### withRequestCancelExternalWorkflowExecutionDecisionAttributes

    public Decision withRequestCancelExternalWorkflowExecutionDecisionAttributes(RequestCancelExternalWorkflowExecutionDecisionAttributes requestCancelExternalWorkflowExecutionDecisionAttributes)

Provides details of the `RequestCancelExternalWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `requestCancelExternalWorkflowExecutionDecisionAttributes` - Provides details of the `RequestCancelExternalWorkflowExecution` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setStartChildWorkflowExecutionDecisionAttributes

    public void setStartChildWorkflowExecutionDecisionAttributes(StartChildWorkflowExecutionDecisionAttributes startChildWorkflowExecutionDecisionAttributes)

Provides details of the `StartChildWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `startChildWorkflowExecutionDecisionAttributes` - Provides details of the `StartChildWorkflowExecution` decision. It is not set for other decision types.

#### getStartChildWorkflowExecutionDecisionAttributes

    public StartChildWorkflowExecutionDecisionAttributes getStartChildWorkflowExecutionDecisionAttributes()

Provides details of the `StartChildWorkflowExecution` decision. It is not set for other decision types.

Returns:
  Provides details of the `StartChildWorkflowExecution` decision. It is not set for other decision types.

#### withStartChildWorkflowExecutionDecisionAttributes

    public Decision withStartChildWorkflowExecutionDecisionAttributes(StartChildWorkflowExecutionDecisionAttributes startChildWorkflowExecutionDecisionAttributes)

Provides details of the `StartChildWorkflowExecution` decision. It is not set for other decision types.

Parameters:
  `startChildWorkflowExecutionDecisionAttributes` - Provides details of the `StartChildWorkflowExecution` decision. It is not set for other decision types.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setScheduleLambdaFunctionDecisionAttributes

    public void setScheduleLambdaFunctionDecisionAttributes(ScheduleLambdaFunctionDecisionAttributes scheduleLambdaFunctionDecisionAttributes)

Parameters:
  `scheduleLambdaFunctionDecisionAttributes` -

#### getScheduleLambdaFunctionDecisionAttributes

    public ScheduleLambdaFunctionDecisionAttributes getScheduleLambdaFunctionDecisionAttributes()

Returns:

#### withScheduleLambdaFunctionDecisionAttributes

    public Decision withScheduleLambdaFunctionDecisionAttributes(ScheduleLambdaFunctionDecisionAttributes scheduleLambdaFunctionDecisionAttributes)

Parameters:
  `scheduleLambdaFunctionDecisionAttributes` -
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public Decision clone()

Overrides:
  `clone` in class `Object`